var tbwwPref = {
    _prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.tbww."),
    _mw: Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser"),

    onLoad: function() {
        try {
            document.commandDispatcher.rewindFocus();
            document.commandDispatcher.rewindFocus();
        } catch (e) {
            document.getElementById("detect").focus();
        }

        var path = unescape(this._prefs.getCharPref("exePath"));
        if (!path) path = this._mw.TaoBaoWangWang.detectProcess();
        if (path && path != "NS_ERROR_FAILURE")
            document.getElementById("path").value = path;

        document.getElementById("e.urlbarHandler").checked = this._prefs.getBoolPref("urlbarHandler");
    },

    detect: function() {
        var path = this._mw.TaoBaoWangWang.detectProcess();

        if (path && path != "NS_ERROR_FAILURE")
            document.getElementById("path").value = path[0];
        else
            alert(document.getElementById("prefstringmanager").getString("detectFail"));
    },

    onOK: function() {
        this._prefs.setBoolPref("urlbarHandler", document.getElementById("e.urlbarHandler").checked);

        var path = this.trim(document.getElementById("path").value);
        if (path) {
            if (this._mw.TaoBaoWangWang._inited)
                this._mw.TaoBaoWangWang._process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);

           this._prefs.setCharPref("exePath", escape(path));
           switch (this._mw.TaoBaoWangWang.initProcess(path)) {
                case "NS_ERROR_FILE_UNRECOGNIZED_PATH":
                case "NS_ERROR_FILE_NOT_FOUND":
                    alert(document.getElementById("prefstringmanager").getString("initFail"));
                    return false;
                default:
                    break;
            }
        }
    },

    openFileDlg: function() {
        var nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, document.getElementById("prefstringmanager").getString("plsSelectFile"), nsIFilePicker.modeOpen);
        fp.appendFilters(nsIFilePicker.filterApps);

        var fpShow = fp.show();
        if (fpShow == nsIFilePicker.returnOK) document.getElementById("path").value = fp.file.path;
    },

    loadHelp: function() {
        this._mw.gBrowser.loadOneTab("http://taobaowangwang.mozdev.org/", null, null, null, false, false);
    },

	trim: function(s) {
	   if (s) return s.replace(/^\s+/,"").replace(/\s+$/,""); else return null;
	},

}  //var end

